package com.jz.dm.models.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * @ClassName:
 * @Author: Carl
 * @Date: 2021/1/22
 * @Version:
 */
@ApiModel(value = "数据银行查询用户调用数和错误率返回参数")
@Data
public class DataBankNumberErrorDto implements Serializable {

    @ApiModelProperty(value = "apiKey")
    private String apiKey;

    @ApiModelProperty(value = "客户请求token")
    private String requestToken;

    @ApiModelProperty(value = "调用数")
    private String callNumber;

    @ApiModelProperty(value = "错误率")
    private String errorRate;

    @ApiModelProperty(value = "成功数")
    private String scSuccess;

    @ApiModelProperty(value = "错误数")
    private String wrongNumber;
}
