package com.jz.dm.models.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.models.dto
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: DataFileDto
 * @DATE: 2021-2-4/17:23
 * @DAY_NAME_SHORT: 周四
 * @Description:
 **/
@Data
@ApiModel
public class DataFileDto implements Serializable {

    @ApiModelProperty(value = "文件id")
    private Long id;
    @ApiModelProperty(value = "项目编号")
    private Long projectId;

    @ApiModelProperty(value = "组织编码")
    private String orgCode;
    @ApiModelProperty(value = "父类id")
    private Long parentId;
    @ApiModelProperty(value = "文件名称")
    private String name;
    @ApiModelProperty(value = "子类集合")
    private List<DataFileDto> children;
}
