package com.jz.dm.models.req.auth;

import com.jz.common.bean.BasePageBean;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.models.req.auth
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: ServiceAuthReq
 * @DATE: 2021-1-28/11:50
 * @DAY_NAME_SHORT: 周四
 * @Description:
 **/
@Data
@ApiModel(value = "服务授权请求体")
public class ServiceAuthReq extends BasePageBean implements Serializable {
    @ApiModelProperty(value = "文件夹id",required = false)
    private Long fileId;
    @ApiModelProperty(value = "组织编码",required = false)
    private String orgCode;
    @ApiModelProperty(value = "组织名称",required = false)
    private String orgName;
    @ApiModelProperty(value = "api名称",required = false)
    private String apiName;

}
