package com.jz.dm.models.req.producer;

import com.jz.common.bean.BasePageBean;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.models.req.producer
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: ServiceIssueReq
 * @DATE: 2021-1-28/11:00
 * @DAY_NAME_SHORT: 周四
 * @Description:
 **/
@Data
@ApiModel(value = "服务发布请求体")
public class ServiceIssueReq  extends BasePageBean implements Serializable {

    @ApiModelProperty(value = "文件夹id",required = false)
    private Long fileId;

    @ApiModelProperty(value = "api名称",required = false)
    private String apiName;
    @ApiModelProperty(value = "apiId",required = false)
    private String apiId;

}
